/***************************************************************************************
*									KoSi_Gen.c
*
* WinAVR Vers.:			
*
* AVR-Studio Version:	5
*
* Autor: 				Rick
*
* Getestet:						
*
* Letzte nderung:		
*
***************************************************************************************/

#include "KoSi_Gen.h"

// ********************************** MAIN *******************************************

int main(void)
{
    
	adc_init();
	timer1_init();
	lcd_init(LCD_DISP_ON);
	//uart_init(UART_BAUD_SELECT(UART_BAUD_RATE,XTAL));
	sei();	
	
	DDRA = 0x00;		// PORTA Pin0 bis 6 fr Testzwecke nicht bentzt ->Eingang + Pull Up EIN
	PORTA |= (1<<PA0) | (1<<PA1) | (1<<PA2) | (1<<PA3)| (1<<PA4) | (1<<PA5) | (1<<PA6);
	PORTA &= ~(1<<PA7); // PA7 fr Tasten auf high-z


	DDRC = 0xFF;		// PORTC als Ausgang (LEDs)
	PORTC = 0xFF;		// Alle LEDs aus
	
	DDRD |= (1<<PD2) | (1<<PD3) | (1<<PD4) | (1<<PD5)| (1<<PD6) | (1<<PD7);		// PORTD Pin 2 bis Pin7 als Eingang ,da unbentzt
	PORTD |= (1<<PD2) | (1<<PD3) | (1<<PD4) | (1<<PD5)| (1<<PD6) | (1<<PD7);	// Interne Pull-Up ein
																			// PD0 + PD1 fr RS232
	second_puls = 0;
	button_read_puls = 0;
	
	
//********************************* HAUPTSCHLEIFE *************************************	
	while(1)		
    {
		
		//***************************** TASTENABFRAGE *********************************
			 
		if(button_read_puls == 2)			// 8msec vergangen
			button1 = read_button();		// Tasten auslesen 
			
		if(button_read_puls == 4)			// weitere 8msec vergangen
			button2 = read_button();		// Tasten auslesen
						
					
			
		
		if( button1 == button2 )			// Nach 8msec noch selbe Taste erkannt ?
		{	
			switch ( button2 )				// Handlung zuweisen
			{
				char string [12];
		
		
				case 0: break;					// keine Taste gedrckt
		
				case 1:							// wenn Taste 1 gedrckt, Generator 
					if(gen_on == 0)					// EIN bzw. AUS schalten 
						gen_on = 1;
				else
					gen_on = 0;
					break;
		 
				case 2:							// Taste 2
					if(gen_on == 1) break;		// keine Verstellmglichkeit bei eingesch. Gert
			
					if(++hour_countdown == 11)	// pro Tastendruck +1 Stunde, 
						hour_countdown = 0;		// bei 11h auf 0 zurcksetzen
					break;
		
				case 3:							// Taste 3
					if(gen_on == 1) break;		// keine Verstellmglichkeit bei eingesch. Gert
			
					minute_countdown += 10;		// pro Tastendruck +10min
					if(minute_countdown == 60)	// werden 60min erreicht, auf 10min zurcksetzen
						minute_countdown = 10;
					break;
		
				case 4:							// Taste 4
					if(gen_on == 1) break;		// keine Verstellmglichkeit bei eingesch. Gert
			
					if(++ac_period == 31)		// AC-Puls-Periode, pro Tastendruck +1sec
						ac_period = 1;			// bei 31sec auf 1sec zurcksetzen
					break;
		
				case 5:							// Taste 5
					if(gen_on == 1) break;		// keine Verstellmglichkeit bei eingesch. Gert
			
					if(current_mode == 0)		// Strom-Modus, AD oder DC
						current_mode = 1;
					else
						current_mode = 0;
					break;
		
				case 99:						// FEHLER
					PORT_MAIN_SWITCH &= ~(1<<PIN_MAIN_SWITCH);		// Gert ausschalten
			
					lcd_clrscr();
					lcd_puts("ERROR_BUTTON");			// Fehlerausgabe: Tastenabfrage Fehler!	
					lcd_gotoxy(0,1);
					lcd_puts("ADC:");
					itoa (adc_value_button, string, 10);
					lcd_puts(string);
			
					for(uint8_t i=0 ; i<=63 ; i++)	// 1sec warten
						_delay_ms(16);
					break;
		
				default:
					break;
			}			
		}		
		
		
		//************************** ANALOGWERTE AUSLESEN **********************	
		/*
		voltage_source = read_voltage_source();
		voltage_electrodes = read_voltage_electrodes();
		current_electrodes = read_current_electrodes();
		*/
		
		//************************ AUSGNGE SETZEN *************************************
		
		//******** Gert AUS
		
		if(gen_on == 0)
		{
			PORT_MAIN_SWITCH &= ~(1<<PIN_MAIN_SWITCH);		// Gert ausschalten
			PORT_AC_SWITCH &= ~(1<<PIN_AC_SWITCH);			// AC Ausgang auf 0
		}
		
		//******** Gert EIN *** DC-Mode
		
		if( (gen_on == 1) && (current_mode == 0) )			// Gert EIN, DC-Mode
			PORT_MAIN_SWITCH |= (1<<PIN_MAIN_SWITCH);		// Gert EIN
			
		
		//******** Gert EIN *** AC-Mode
		
		if( (gen_on == 1) && (current_mode == 1) )			// Gert EIN, AC-Mode
		{
			PORT_MAIN_SWITCH |= (1<<PIN_MAIN_SWITCH);		// Gert EIN
			
			if(second_puls == 1)
				ac_time++;
			
			if(ac_time == ac_period)
			{
				PORT_AC_SWITCH ^= (1<<PIN_AC_SWITCH);		// AC-Ausgang toggeln
				ac_time = 0;								// Zhler rcksetzen
			}
		}			
			
			
				
		//************************** COUNTDOWN ***************************************
		
		if (gen_on && second_puls)		// wenn Gert eingeschaltet und Sekundenpuls da
		{
			second_countdown--;				// Sekunde -1
			
			if( second_countdown == -1)		// wenn Sekunden abgelaufen
			{
				
				if( (minute_countdown > 0) || (hour_countdown > 0) )
				{											// wenn Restzeit vorhanden	
					second_countdown = 59;					// Sekunden wieder auf 59
					minute_countdown = minute_countdown -1;		// Minuten -1
				}
			
				else if( (minute_countdown == -1) && (hour_countdown > 0) )	
				{							// wenn Minuten abgelaufen und Restzeit da
					minute_countdown = 59;						// Minuten wieder auf 59
					hour_countdown = hour_countdown -1;			// Stunden -1
				}
			
			
				else
					gen_on = 0;									// Gert ausschalten
			}
		}		
		
		
	
		
		
		
		
		//************************** DISPLAY AUSGABE ***************************
		
		if(second_puls == 0)			// Display-Ausgabe nur 1x pro Sekunde
			display_lcd_page1();		// Anzeigeseite 1 am LCD ausgeben
		
		
	
	
	
	
	 
	    
	}    
}